<?php

namespace Drupal\interactive_queue_processing\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * Queue processing controller.
 */
class Process extends ControllerBase {

  /**
   * The time service.
   *
   * @var \Drupal\Component\Datetime\TimeInterface
   */
  protected $time;

  /**
   * The queue manager service.
   *
   * @var \Drupal\interactive_queue_processing\QueueManager
   */
  protected $queueManager;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    $controller = parent::create($container);
    $controller->time = $container->get('datetime.time');
    $controller->queueManager = $container->get('interactive_queue_processing.queue_manager');
    return $controller;
  }

  /**
   * Handles AJAX queue processing.
   *
   * @return \Symfony\Component\HttpFoundation\JsonResponse
   *   The response.
   */
  public function ajax() {
    $this->queueManager->processQueues();

    $response = new JsonResponse();
    $response->setData([
      'timestamp' => $this->time->getCurrentMicroTime(),
      'remaining' => $this->queueManager->queueCounts(),
    ]);
    return $response;
  }

}
